
import javax.swing.*;
import java.awt.*;
import java.util.*;

public class Display extends JPanel{
	//Pixel size square
	private final int SIZE = 500;
	private long startTime = (new Date()).getTime();
	private final int NUMBEING = 30;
	private final boolean SHOWVISION = false;
	private final double FOODFREQUENCY = .90;
	private ArrayList<Being> beings = new ArrayList<Being>();
	private ArrayList<Food> food = new ArrayList<Food>();
	private Thread drawThread;
	private Random rand = new Random();
	public Display() //of affection
	{
		super();
		setPreferredSize(new Dimension(SIZE, SIZE));
		for (int i = 0; i < NUMBEING; i++)
			beings.add(new Being());
		
		drawThread = new Thread(){
			public void run()
			{
				while(true)
				{
					repaint();
					try{
					drawThread.sleep(10);
					} catch (Exception e){;}
				}
			}
		};
		drawThread.start();
	}

	public void paintComponent(Graphics g2)
	{
		boolean done = true;
		for (int i = 0; i < beings.size(); i++)
				if(beings.get(i).eaten)
					beings.remove(i);
		for (int i = 0; i < food.size(); i++)
			if(food.get(i).eaten)
				food.remove(i);
	
		Graphics2D g = (Graphics2D) g2;
		g.setColor(Color.WHITE);
		g.fillRect(0, 0, SIZE, SIZE);
		g.setColor(Color.GRAY);
		long now = (new Date()).getTime();
		if (SHOWVISION)
		for (Habitant h : beings)
			if (h instanceof Being)
			{
				g.draw(((Being)h).getSight());
			}
		for (Food h: new ArrayList<Food>(food))
		{
			g.setColor(Color.green);
			g.fillOval(h.getX()-h.size/2,h.getY()-h.size/2, h.size, h.size);
		}	
		for (Being h : new ArrayList<Being>(beings))
		{
			
			done = false;
			g.setColor(((Being)h).traits.color);
			g.fillOval(h.getX()-h.size/2,h.getY()-h.size/2, h.size, h.size);
			h.step(now, beings,food);
		}
		if (rand.nextDouble() > FOODFREQUENCY)
			food.add(new Food());
		
		if (done)
		{
			System.out.println(((new Date()).getTime() - startTime)/60000);
			drawThread.stop();
		}
	}

}
